Description

Hi,

With Foreman version 1.5.2 I'm not able filtering the hostlist based on classes. Regardless of which class i try to filter with, Foreman

returns all hosts as a result.

Example of filter: class = java

This query should return a few hosts but it returns all hosts.

I did some search and found an old bug (http://projects.theforeman.org/issues/4314). But I believe the cause isn't the same.

After I enabled debug mode. Here's the error I get when applying the class filter:

@  Host::Managed Load (0.3ms)  SELECT `hosts`.* FROM `hosts` WHERE `hosts`.`type` IN ('Host::Managed') LIMIT 1

(0.5ms)  SELECT id FROM `config_groups` INNER JOIN `config_group_classes` ON `config_group_classes`.`config_group_id` =

`config_groups`.`id` INNER JOIN `puppetclasses` ON `puppetclasses`.`id` = `config_group_classes`.`puppetclass_id` WHERE

(puppetclasses.name = BINARY 'java') ORDER BY config_groups.name

Mysql2::Error: Column 'id' in field list is ambiguous: SELECT id FROM `config_groups` INNER JOIN `config_group_classes` ON

`config_group_classes`.`config_group_id` = `config_groups`.`id` INNER JOIN `puppetclasses` ON `puppetclasses`.`id` =

`config_group_classes`.`puppetclass_id` WHERE (puppetclasses.name = BINARY 'java') ORDER BY config_groups.name

(0.2ms)  SELECT COUNT() FROM `user_facts` WHERE `user_facts`.`user_id` = 2

Host::Managed Load (1.0ms)  SELECT `hosts`. FROM `hosts` WHERE `hosts`.`type` IN ('Host::Managed') ORDER BY

`hosts`.`name` ASC LIMIT 25 OFFSET 0

Hostgroup Load (0.5ms)  SELECT `hostgroups`.* FROM `hostgroups` WHERE `hostgroups`.`id` IN (30, 20, 19, 16, 17, 12, 13, 10, 9,

6, 5, 27, 25, 24) ORDER BY hostgroups.title

Operatingsystem Load (0.3ms)  SELECT `operatingsystems`.* FROM `operatingsystems` WHERE `operatingsystems`.`id` IN (5, 6,

1, 4) ORDER BY operatingsystems.name

@

The error states an ambiguous field 'id'. I modified the query by adding the tablename, but altough I got an empty result ... don't know

whether there's another root cause of this problem.

Let me know if more information is needed.

Regards

Reto

Related issues:

Related to Foreman - Bug #5848: Can't search for host with class inherited fr... Closed 05/21/2014

Has duplicate Foreman - Bug #7185: search for host by included class name doe... Duplicate 08/20/2014

Associated revisions

Revision f06b276b - 09/01/2014 07:13 AM - Dominic Cleal

fixes #7035 - expand column name for Rails 3.2.8 compat in Puppet class search

05/17/2024 1/2

http://projects.theforeman.org/issues/4314


Revision 9c3bf3f1 - 09/04/2014 04:00 PM - Dominic Cleal

fixes #7035 - expand column name for Rails 3.2.8 compat in Puppet class search

(cherry picked from commit f06b276b93f9ff47ca66174c606fee6fc2c64321)

Revision 8fd7cfb2 - 09/08/2014 02:33 PM - Dominic Cleal

fixes #7035 - expand column name for Rails 3.2.8 compat in Puppet class search

(cherry picked from commit f06b276b93f9ff47ca66174c606fee6fc2c64321)

History

#1 - 08/15/2014 06:42 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version set to 1.7.5

- Pull request https://github.com/theforeman/foreman/pull/1692 added

- Pull request deleted ()

#2 - 08/15/2014 06:43 AM - Dominic Cleal

- Assignee set to Dominic Cleal

#3 - 08/15/2014 06:43 AM - Dominic Cleal

- Related to Bug #5848: Can't search for host with class inherited from config group added

#4 - 08/18/2014 02:40 AM - Reto Vogel

Thank you Dominic. I've just tested your fix and it works perfectly! Filtering on classes does work again like a charm.

Cheers

#5 - 08/20/2014 06:51 AM - Anonymous

- Target version changed from 1.7.5 to 1.7.4

#6 - 08/21/2014 03:30 AM - Dominic Cleal

- Has duplicate Bug #7185: search for host by included class name does not filter host results added

#7 - 08/22/2014 12:46 AM - Glen Ogilvie

tested patch on my system, as affected by this as well.  Patch works

#8 - 08/26/2014 03:47 AM - Dominic Cleal

- Has duplicate Bug #7256: host filter - params seach not working added

#9 - 08/26/2014 04:30 AM - Dominic Cleal

- Has duplicate deleted (Bug #7256: host filter - params seach not working)

#10 - 08/26/2014 05:59 AM - Dominic Cleal

- translation missing: en.field_release set to 20

#11 - 09/01/2014 03:44 AM - Stephen Benjamin

- Bugzilla link set to 1135919

#12 - 09/01/2014 08:01 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset f06b276b93f9ff47ca66174c606fee6fc2c64321.
